#!/usr/bin/perl -w 

##j'ai fait la modification. Voici le mert-ncoder.pl.
##Maxruns est le nombre maxi d'itrations (decodings).

use File::Basename;
use Dumpvalue;
my $dumper = new Dumpvalue;

# defaults for initial values and ranges for randomized values during the parameter search :
# NOTE: ranges are not used yet in this version
#jmcrego  my $default_triples = {
#jmcrego      # these two basic models exist even if not specified, they are
#jmcrego      # not associated with any model file
#jmcrego      "b" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "t" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "tt" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "ts" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "p" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "s" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "n" => [ [ 1.0, 0.0, 2.0 ] ],  # 
#jmcrego      "g1" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g2" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g3" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g4" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g5" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g6" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g7" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g8" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "g9" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "1" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "2" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "3" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "4" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "5" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "6" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "7" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "8" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego      "9" => [ [ 1.0, 0.0, 1.0 ] ],  # 
#jmcrego  };

my $minimum_required_change_in_weights = 0.00001;
    # stop if no lambda changes more than this
my $max_runs=100;
    # stop if done that many runs
my $mert_ntry=20;
    # -n parameter for mert

my $BINCODER = $ENV{'BINCODER'};
my $usage = 0; # request for --help
my $___WORKING_DIR = "mert-ncoder";
my $___DEV_F = undef; # required, input text to decode
my $___DEV_E = undef; # required, basename of files with references
my $___DECODER = "$BINCODER/bin/bincoder"; # required, pathname to the decoder executable
###jmcrego my $___EVAL_DIR = "$BINCODER/src/Evaluate"; # required, pathname to the eval n-code script directory
my $___EVAL_DIR = "$BINCODER/bin"; # required, pathname to the eval n-code script directory
my $___N_BEST_LIST_SIZE = 100;
my $___JOBS = undef; # if parallel, number of jobs to use (undef -> serial)
my $___DECODER_FLAGS = ""; # additional parametrs to pass to the decoder
my $___LAMBDA = undef; # string specifying the seed weights and boundaries of all lambdas
my $mteval = 0;
# set 0 if input type is text, set 1 if input type is confusion network
my $___INPUTTYPE = 0; 
my $mertdir = $ENV{'MERT'};
my $mertargs = undef; # args to pass through to mert
my $ncoder_parallel_cmd = undef;
my $prev_aggregate_nbl_size = -1; # number of previous step to consider when loading data (default =-1)
                                  # -1 means all previous, i.e. from iteration 1
                                  # 0 means no previous data, i.e. from actual iteration
                                  # 1 means 1 previous data , i.e. from the actual iteration and from the previous one
                                  # and so on 
my $distribute_prev_nbl = 0;

use strict;
use Getopt::Long;
GetOptions(
  "maxruns=i" => \$max_runs,
  "mert-ntry=i" => \$mert_ntry,
  "min-change-in-weights=f" => \$minimum_required_change_in_weights,
  "working-dir=s" => \$___WORKING_DIR,
  "input=s" => \$___DEV_F,
  "refs=s" => \$___DEV_E,
  "decoder=s" => \$___DECODER,
  "decoder-flags=s" => \$___DECODER_FLAGS,
  "evaldir=s" => \$___EVAL_DIR,
  "nbest=i" => \$___N_BEST_LIST_SIZE,
  "jobs=i" => \$___JOBS,
  "lambdas=s" => \$___LAMBDA,
  "mertdir=s" => \$mertdir,
  "mertargs=s" => \$mertargs,
  "help" => \$usage,
  "mteval" => \$mteval,
  "prev-aggregate-nbestlist=i" => \$prev_aggregate_nbl_size, #number of previous step to consider when loading data (default =-1, i.e. all previous)
  "distribute-prev-nbestlist=i" => \$distribute_prev_nbl, #instead of aggregating the previous $prev_aggregate_nbl_size nbest lists, considers one list every nrun/$prev_aggregate_nbl_size approx;
) or exit(1);

# the 3 required parameters can be supplied on the command line directly
# or using the --options
if (scalar @ARGV == 3) {
  # required parameters: input_file references_basename decoder_executable
  $___DEV_F = shift;
  $___DEV_E = shift;
  $___DECODER = shift;
}

if ($usage || !defined $___DEV_F || !defined$___DEV_E || !defined$___DECODER ) {
  print STDERR "usage: mert-ncoder.pl input-graph references decoder-executable 
Options:
  --maxruns=N ... max number of runs that will be done [default 100]
  --mert-ntry=N ... n parameter of mert [default 20]
  --min-change-in-weights=N ... stops if no lambda is changed more that this value [default 0.00001]
  --working-dir=mert-dir ... where all the files are created
  --input=file ... devset source input graph
  --refs=file ... reference file base name
  --decoder=STRING ... path to decoder
  --decoder-flags=STRING ... extra parameters for the decoder
  --graphdir=STRING ... path to n-coder graph script directory (graph2nbest, ncoder2moses_nbest.pl)
  --evaldir=STRING ... path to n-coder eval script directory (evaluate.perl)
  --nbest=100 ... how big nbestlist to generate
  --jobs=N  ... set this to anything to run the N-coder in parallel
  --lambdas=STRING  ... default lambda values , a string such as 'lb:1 lt:1'
  --mertdir=STRING ... path to new mert implementation
  --mertargs=STRING ... extra args for mert, eg to specify scorer
  --prev-aggregate-nbestlist=INT  ... number of previous step to consider when loading data (default =-1)
                                      -1 means all previous, i.e. from iteration 1
                                      0 means no previous data, i.e. from actual iteration
                                      1 means 1 previous data , i.e. from the actual iteration and from the previous one
                                      and so on 
  --distribute-prev-nbestlist  ... distributes the aggregated n-best lists equally between runs, instead of considering the last ones only. For example at run 10, if prev-aggregate-nbestlist=4, it will agreggate lists of runs 1,4,7,10 instead of runs 7,8,9,10.
";
  exit 1;
}

# Check validity of input parameters and set defaults if needed

my $mert_extract_cmd = "$mertdir/extractor";
my $mert_mert_cmd = "$mertdir/mert";
die "Not executable: $mert_extract_cmd" if ! -x $mert_extract_cmd;
die "Not executable: $mert_mert_cmd" if ! -x $mert_mert_cmd;
$mertargs = "" if !defined $mertargs;
my $mert_extract_args=$mertargs;
my $mert_mert_args=$mertargs;
$mert_mert_args =~ s/\-+(binary|b)\b//;

die "Not executable: $___DECODER" if ! -x $___DECODER;
my $decoder_abs = ensure_full_path($___DECODER);
die "File not found: $___DECODER (interpreted as $decoder_abs)."
  if ! -x $decoder_abs;
$___DECODER = $decoder_abs;

###jmcrego my $___MULTIBLEU="$___EVAL_DIR/multi-bleu.perl";
###jmcrego die "Not executable: $___MULTIBLEU" if ! -x $___MULTIBLEU;
my $___EVALUATE="$___EVAL_DIR/evaluate.perl";
die "Not executable: $___EVALUATE" if ! -x $___EVALUATE;

my $input_abs = ensure_full_path($___DEV_F);
die "File not found: $___DEV_F (interpreted as $input_abs)."
  if ! -e $input_abs;
$___DEV_F = $input_abs;

my $ref_abs = ensure_full_path($___DEV_E);
# check if English dev set (reference translations) exist and store a list of all references
my @references;
my $singleref=1;
if (-e $ref_abs) {
  push @references, $ref_abs;
}
else {
  # if multiple file, get a full list of the files
    my $part = 0;
    while (-e $ref_abs.$part) {
        push @references, $ref_abs.$part;
        $part++;
    }
    die("Reference translations not found: $___DEV_E (interpreted as $ref_abs)") unless $part;
    $singleref=0;
}

#jmcrego   my %used_triples = %{$default_triples};
my %used_triples;

# Parse the lambda config string and convert it to a nice structure in the same format as $used_triples
if (defined $___LAMBDA) {
  my %specified_triples;
  # interpreting lambdas from command line
  foreach (split(/\s+/,$___LAMBDA)) {
      my ($name,$start) = split(/:/);
      $name=~s/^l//;
      die "Malformed setting: '$_', expected name:values\n" if !defined $name || !defined $start;
      my $min=0;
      my $max=1;
#jmcrego      my $min=$default_triples->{$name}->[0][1];
#jmcrego      my $max=$default_triples->{$name}->[0][2];
      push @{$specified_triples{$name}}, [$start, $min, $max];
  }
  %used_triples = %specified_triples;
}
#$dumper->dumpValue(\%used_triples);

my @order_of_lambdas_from_decoder = ();
# this will store the labels of scores coming out of the decoder (and hence the order of lambdas coming out of mert)
# we will use the array to interpret the lambdas
# the array gets filled with labels only after first nbestlist was generated

#store current directory and create the working directory (if needed)
my $cwd = `pwd`;
chomp($cwd);
safesystem("mkdir -p $___WORKING_DIR") or die "Can't mkdir $___WORKING_DIR";

{
# open local scope

#chdir to the working directory
chdir($___WORKING_DIR) or die "Can't chdir to $___WORKING_DIR";

# fixed file names
my $mert_logfile = "mert.log";
my $weights_in_file = "init.opt";
my $weights_out_file = "weights.txt";


# set start run
my $PARAMETERS = $___DECODER_FLAGS;

my $devbleu = undef;
my $bestpoint = undef;
my $run=0;

my $cmd;
# features and scores from the last run.
my $prev_feature_file=undef;
my $prev_score_file=undef;
my $nbest_file=undef;

while($run < $max_runs) {
    $run++;
    # run beamdecoder with option to output nbestlists
    # the end result should be (1) @NBEST_LIST, a list of lists; (2) @SCORE, a list of lists of lists
    
    print "run $run start at ".`date`;
    
    print "($run) run decoder to produce n-best lists\n";
    $nbest_file = run_decoder(\%used_triples, $PARAMETERS, $run, \@order_of_lambdas_from_decoder);
    safesystem("gzip -f $nbest_file") or die "Failed to gzip run*out";
    $nbest_file = $nbest_file.".gz";
    
    # extract score statistics and features from the nbest lists
    print STDERR "Scoring the nbestlist.\n";
    
    my $base_feature_file = "features.dat";
    my $base_score_file = "scores.dat";
    my $feature_file = "run$run.${base_feature_file}";
    my $score_file = "run$run.${base_score_file}";
    
    $cmd = "$mert_extract_cmd $mert_extract_args --scfile $score_file --ffile $feature_file  -r ".join(",", @references)." -n $nbest_file";

    safesystem("$cmd > extract.out 2> extract.err") or die "Failed to do extraction of statistics.";

    # Create the initial weights file for mert, in init.opt
    # mert reads in the file init.opt containing the current
    # values of lambda.

    # We need to prepare the files and **the order of the lambdas must
    # correspond to the order @order_of_lambdas_from_decoder
    
    # NB: This code is copied from the old version of mert-moses.pl,
    # even though the max,min and name are not yet used in the new
    # version.
    
    my @MIN = ();   # lower bounds
    my @MAX = ();   # upper bounds
    my @CURR = ();  # the starting values
    my @NAME = ();  # to which model does the lambda belong
    
    # walk in order of @order_of_lambdas_from_decoder and collect the min,max,val
    my %visited = ();
    foreach my $name (@order_of_lambdas_from_decoder) {
	next if $visited{$name};
	$visited{$name} = 1;
	if (!defined $used_triples{$name})
	{
	    die "The decoder produced also some '$name' scores, but we do not know the ranges for them, no way to optimize them\n";
	}
      
	my $count = 0;
	foreach my $feature (@{$used_triples{$name}}) {
	    $count++;
	    my ($val, $min, $max) = @$feature;
	    push @CURR, $val;
	    push @MIN, $min;
	    push @MAX, $max;
	    push @NAME, $name;
	}
    }

    open(OUT,"> $weights_in_file") or die "Can't write $weights_in_file (WD now $___WORKING_DIR)";
    print OUT join(" ", @CURR)."\n";
    print OUT join(" ", @MIN)."\n"; ##jmcrego
    print OUT join(" ", @MAX)."\n"; ##jmcrego
    close(OUT);
  
    # make a backup copy labelled with this run number
    safesystem("\\cp -f $weights_in_file run$run.$weights_in_file") or die;

    my $DIM = scalar(@CURR); # number of lambdas
    
    # run mert
    $cmd = "$mert_mert_cmd -d $DIM $mert_mert_args -n $mert_ntry";
    if (defined $prev_feature_file) {
	$cmd = $cmd." --ffile $prev_feature_file,$feature_file";
    }
    else{
	$cmd = $cmd." --ffile $feature_file";
    }
    if (defined $prev_score_file) {
	$cmd = $cmd." --scfile $prev_score_file,$score_file";
    }
    else{
	$cmd = $cmd." --scfile $score_file";
    }
    safesystem("$cmd 2> $mert_logfile") or die "Failed to run mert";
    die "Optimization failed, file $weights_out_file does not exist or is empty"
	if ! -s $weights_out_file;

    # backup copies
    safesystem ("\\cp -f extract.err run$run.extract.err") or die;
    safesystem ("\\cp -f extract.out run$run.extract.out") or die;
    safesystem ("\\cp -f $mert_logfile run$run.$mert_logfile") or die;
    safesystem ("touch $mert_logfile run$run.$mert_logfile") or die;
    safesystem ("\\cp -f $weights_out_file run$run.$weights_out_file") or die; # this one is needed for restarts, too

    print "run $run end at ".`date`;

    $bestpoint = undef;
    $devbleu = undef;
    open(IN,"run$run.$mert_logfile") or die "Can't open run$run.$mert_logfile";
    while (<IN>) {
	if (/Best point:\s*([\s\d\.\-e]+?)\s*=> ([\-\d\.]+)/) {
	    $bestpoint = $1;
	    $devbleu = $2;
	    last;
	}
    }
    close IN;
    die "Failed to parse mert.log, missed Best point there."
	if !defined $bestpoint || !defined $devbleu;
    print "($run) BEST at $run: $bestpoint => $devbleu at ".`date`;
    
    my @newweights = split /\s+/, $bestpoint;
    
    # update my cache of lambda values
    store_new_lambda_values(\%used_triples, \@order_of_lambdas_from_decoder, \@newweights);
    
    ## additional stopping criterion: weights have not changed
    my $shouldstop = 1;
    for(my $i=0; $i<@CURR; $i++) {
	die "Lost weight! mert reported fewer weights (@newweights) than we gave it (@CURR)"
	    if !defined $newweights[$i];
	if (abs($CURR[$i] - $newweights[$i]) >= $minimum_required_change_in_weights) {
	    $shouldstop = 0;
	    last;
	}
    }

    open F, "> finished_step.txt" or die "Can't mark finished step";
    print F $run."\n";
    close F;

    if ($shouldstop) {
	print STDERR "None of the weights changed more than $minimum_required_change_in_weights. Stopping.\n";
	last;
    }

    my $firstrun;
    my @aggregate_runs;
    if ($prev_aggregate_nbl_size==-1){
	$firstrun=1;
	for (my $i=1;$i<=$run;$i++){push @aggregate_runs,$i;}
    }
    else{
	if ($distribute_prev_nbl && $run>$prev_aggregate_nbl_size){
	    for (my $i=0;$i<$prev_aggregate_nbl_size;$i++){		
		my $dist_run=1+int($i*($run-1)/($prev_aggregate_nbl_size-1) + .5);
		push @aggregate_runs,$dist_run;
	    }
	}else{
	    $firstrun=$run-$prev_aggregate_nbl_size+1;
	    $firstrun=($firstrun>0)?$firstrun:1;
	    for (my $i=$firstrun;$i<=$run;$i++){push @aggregate_runs,$i;}
	}
    }
    print "loading data from $firstrun to $run (prev_aggregate_nbl_size=$prev_aggregate_nbl_size)\n";
    $prev_feature_file = undef;
    $prev_score_file = undef;
    foreach my $i (@aggregate_runs){
#    for (my $i=$firstrun;$i<=$run;$i++){ 
	if (defined $prev_feature_file){
	    $prev_feature_file = "${prev_feature_file},run${i}.${base_feature_file}";
	}
	else{
	    $prev_feature_file = "run${i}.${base_feature_file}";
	}
	if (defined $prev_score_file){
	    $prev_score_file = "${prev_score_file},run${i}.${base_score_file}";
	}
	else{
	    $prev_score_file = "run${i}.${base_score_file}";
	}
    }
    print "loading data from $prev_feature_file\n";
    print "loading data from $prev_score_file\n";
    
} # end of "while run < maxrun" loop
print "Training finished at ".`date`;

safesystem("\\cp -f $weights_in_file run$run.$weights_in_file") or die;
safesystem("\\cp -f $mert_logfile run$run.$mert_logfile") or die;

# just to be sure that we have the really last finished step marked
open F, "> finished_step.txt" or die "Can't mark finished step";
print F $run."\n";
close F;

#chdir back to the original directory # useless, just to remind we were not there
chdir($cwd);

} # end of local scope

sub store_new_lambda_values {
  # given new lambda values (in given order), replace the 'val' element in our triples
  my $triples = shift;
  my $names = shift;
  my $values = shift;

  my %idx = ();
  foreach my $i (0..scalar(@$values)-1) {
    my $name = $names->[$i];
    die "Missed name for lambda $values->[$i] (in @$values; names: @$names)"
      if !defined $name;
    if (!defined $idx{$name}) {
      $idx{$name} = 0;
    } else {
      $idx{$name}++;
    }
    die "We did not optimize '$name', but moses returned it back to us"
      if !defined $triples->{$name};
    die "Moses gave us too many lambdas for '$name', we had ".scalar(@{$triples->{$name}})
      ." but we got at least ".$idx{$name}+1
      if !defined $triples->{$name}->[$idx{$name}];

    # set the corresponding field in triples
    # print STDERR "Storing $i-th score as $name: $idx{$name}: $values->[$i]\n";
    $triples->{$name}->[$idx{$name}]->[0] = $values->[$i];
  }
}

sub run_decoder {
    my ($triples, $parameters, $run, $output_order_of_lambdas) = @_;
    my $filename_template = "run%d.best$___N_BEST_LIST_SIZE.out";
    my $filename = sprintf($filename_template, $run);
    
    print "params = $parameters\n";
    print "references = @references\n";
    # prepare the decoder config:
    my $decoder_config = "";
    my @vals = ();
    foreach my $name (keys %$triples) {
      $decoder_config .= "-l$name ";
      foreach my $triple (@{$triples->{$name}}) {
        my ($val, $min, $max) = @$triple;
        $decoder_config .= "%.6f ";
        push @vals, $val;
      }
    }
    print STDERR "DECODER_CFG = $decoder_config\n";
    print STDERR "     values = @vals\n";
    $decoder_config = sprintf($decoder_config, @vals);
    print "decoder_config = $decoder_config\n";

    # run the decoder
#jmcrego    my $decoder_cmd;
#jmcrego    if (defined $___JOBS) {
#jmcrego	$decoder_cmd="$___DECODER $parameters -decoder-weights \" $decoder_config \" -i $___DEV_F -o run$run.out -jobs $___JOBS";	
#jmcrego	#$decoder_cmd="N-coder-taskfarm.pl -i $input -o $outfile -jobs $nproc -decoder N-coder -decoder-options "$pars $models $weights $search"
#jmcrego	#$opts{mtSystem} -i $opts{src} -o $tmptran $opts{fixedParams} -decoder-weights \"$stringfreepars \" ";	
#jmcrego    } else {
#jmcrego	$decoder_cmd="$___DECODER $parameters $decoder_config -i $___DEV_F -o run$run.out";	
#jmcrego    }

    my $decoder_cmd="$___DECODER $parameters $decoder_config -i $___DEV_F -o run$run.out";	
    safesystem($decoder_cmd) or die "The decoder died. CONFIG WAS $decoder_config \n";

    my $eval_cmd;
    my $bleu_score;
    if ($singleref) {$eval_cmd="$___EVALUATE -tst run$run.out -ref $ref_abs -b > run$run.out.EVAL";}
    else {$eval_cmd="$___EVALUATE -tst run$run.out -refs $ref_abs -b > run$run.out.EVAL";}
    safesystem($eval_cmd) or die "ERROR processing the evaluation command\n";
    $bleu_score=`cat run$run.out.EVAL | cut -d ' ' -f 3`;
    print STDERR "BLEU SCORE for run$run.out:$bleu_score\n";
#jmcrego	$eval_cmd="cat run$run.out | $___MULTIBLEU $ref_abs > run$run.out.EVAL";
#jmcrego	safesystem($eval_cmd) or die "ERROR processing the evaluation command\n";
#jmcrego	$bleu_score=`cut -d ',' -f 1 run$run.out.EVAL | cut -d ' ' -f 3`;
#jmcrego	print STDERR "BLEU SCORE for run$run.out:$bleu_score\n";

    my $nBest_cmd="cp -f run$run.out.NBEST $filename";
    safesystem("$nBest_cmd");
    my $gzipNBEST_cmd="gzip run$run.out.NBEST";
    safesystem("$gzipNBEST_cmd");
    if (0 == scalar @$output_order_of_lambdas) {
      # we have to peek at the nbestlist
      @$output_order_of_lambdas = get_order_of_scores_from_nbestlist($filename);
    } 
    # we have checked the nbestlist already, we trust the order of output scores does not change
    return $filename;
}

sub get_order_of_scores_from_nbestlist {
  # read the first line and interpret the ||| label: num num num label2: num ||| column in nbestlist
  # return the score labels in order
  my $fname_or_source = shift;
  print STDERR "Peeking at the beginning of nbestlist to get order of scores: $fname_or_source\n";
  open IN, $fname_or_source or die "Failed to get order of scores from nbestlist '$fname_or_source'";
  my $line = <IN>;
  close IN;
  die "Line empty in nbestlist '$fname_or_source'" if !defined $line;
  my ($sent, $hypo, $scores, $total) = split /\|\|\|/, $line;
  $scores =~ s/^\s*|\s*$//g;
  die "No scores in line: $line" if $scores eq "";

  my @order = ();
  my $label = undef;
  foreach my $tok (split /\s+/, $scores) {
    if ($tok =~ /^([0-9a-z]*):/i) {
      $label = $1;
    } elsif ($tok =~ /^-?[-0-9.e]+$/) {
      # a score found, remember it
      die "Found a score but no label before it! Bad nbestlist '$fname_or_source'!"
        if !defined $label;
      push @order, $label;
    } else {
      die "Not a label, not a score '$tok'. Failed to parse the scores string: '$scores' of nbestlist '$fname_or_source'";
    }
  }
  print STDERR "The decoder returns the scores in this order: @order\n";
  return @order;
}

sub safesystem {
  print STDERR "Executing: @_\n";
  system(@_);
  if ($? == -1) {
      print STDERR "Failed to execute: @_\n  $!\n";
      exit(1);
  }
  elsif ($? & 127) {
      printf STDERR "Execution of: @_\n  died with signal %d, %s coredump\n",
          ($? & 127),  ($? & 128) ? 'with' : 'without';
      exit(1);
  }
  else {
    my $exitcode = $? >> 8;
    print STDERR "Exit code: $exitcode\n" if $exitcode;
    return ! $exitcode;
  }
}

sub ensure_full_path {
    my $PATH = shift;
    $PATH =~ s/\/nfsmnt//;
    return $PATH if $PATH =~ /^\//;
    my $dir = `pawd 2>/dev/null`; 
    if(!$dir){$dir = `pwd`;}
    chomp($dir);
    $PATH = $dir."/".$PATH;
    $PATH =~ s/[\r\n]//g;
    $PATH =~ s/\/\.\//\//g;
    $PATH =~ s/\/+/\//g;
    my $sanity = 0;
    while($PATH =~ /\/\.\.\// && $sanity++<10) {
        $PATH =~ s/\/+/\//g;
        $PATH =~ s/\/[^\/]+\/\.\.\//\//g;
    }
    $PATH =~ s/\/[^\/]+\/\.\.$//;
    $PATH =~ s/\/+$//;
    $PATH =~ s/\/nfsmnt//;
    return $PATH;
}
