#include "Argument.h"

void Argument::read(int argc, char** argv){
  firstSent=0;
  lastSent=0;
  tnb=25; stacksize=50; strategy="2J"; nthreads=1; nbest=300;
  dropoov=false; units=false; help=false; ograph=false; verbose=false; zmert=false;
  lg=0; ld=0; lp0=0; lp1=0; lp2=0;
  lmc=0; lsc=0; ldc=0; lcc=0; lfc=0; lbc=0; lmp=0; lsp=0; ldp=0; lcp=0; lfp=0; lbp=0;
  if (argc<=1) usage();
  vector<string> Argv;
  int narg=1;
  while (narg<argc) Argv.push_back(argv[narg++]);
  narg=0;
  while (narg<Argv.size()){
    string word=Argv[narg++];
    //I/O files
    if (word.compare("-i")==0 && narg<Argv.size())      {fin=Argv[narg++]; continue;}
    if (word.compare("-o")==0 && narg<Argv.size())      {fout=Argv[narg++]; continue;}
    if (word.compare("-f")==0 && narg<Argv.size())      {firstSent=atoi(Argv[narg++].c_str()); continue;}
    if (word.compare("-l")==0 && narg<Argv.size())      {lastSent=atoi(Argv[narg++].c_str()); continue;}
    //config file
    if (word.compare("-c")==0 && narg<Argv.size()){
      fconf=Argv[narg++]; 
      string line;
      ifstream infile;
      infile.open(fconf.data());
      if (infile.fail()){
	cerr << "error: opening config file " << fconf << endl;
	exit(1);
      }
      while (getline(infile,line)){
	//comments
	if (line.find("#")!=string::npos) line=line.substr(0,line.find("#"));
	istringstream inStrStr(line);
	while (inStrStr){
	  string tok;
	  inStrStr >> tok;
	  if (!inStrStr) continue;
	  Argv.push_back(tok);
	}
      }
      infile.close();
      continue;
    }
    //model files
    if (word.find("-blm")==0 &&narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (fBilLM.size()<=num) fBilLM.push_back("");
      while (BilFactor.size()<=num) BilFactor.push_back(-1);
      while (BilUnk.size()<=num) BilUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -blm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	BilUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fBilLM[num]=name;
      BilFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-tlm")==0 &&narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (fTrgLM.size()<=num) fTrgLM.push_back("");
      while (TrgFactor.size()<=num) TrgFactor.push_back(-1);
      while (TrgUnk.size()<=num) TrgUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -tlm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	TrgUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fTrgLM[num]=name; 
      TrgFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-slm")==0 &&narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (fSrcLM.size()<=num) fSrcLM.push_back("");
      while (SrcFactor.size()<=num) SrcFactor.push_back(-1);
      while (SrcUnk.size()<=num) SrcUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -slm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	SrcUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fSrcLM[num]=name; 
      SrcFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-sblm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsBilLM.size()<=num) fsBilLM.push_back("");
      while (sBilFactor.size()<=num) sBilFactor.push_back(-1);
      while (sBilUnk.size()<=num) sBilUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -sblm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	sBilUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fsBilLM[num]=name; 
      sBilFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-stlm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsTrgLM.size()<=num) fsTrgLM.push_back("");
      while (sTrgFactor.size()<=num) sTrgFactor.push_back(-1);
      while (sTrgUnk.size()<=num) sTrgUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -stlm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	sTrgUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fsTrgLM[num]=name; 
      sTrgFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-sslm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsSrcLM.size()<=num) fsSrcLM.push_back("");
      while (sSrcFactor.size()<=num) sSrcFactor.push_back(-1);
      while (sSrcUnk.size()<=num) sSrcUnk.push_back(0); 
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -sslm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      pos=name.find(",");
      if (pos!=string::npos){
	float incr=atof(name.substr(0,pos).c_str());
	sSrcUnk[num]=incr;
	name=name.substr(pos+1);
      }
      fsSrcLM[num]=name; 
      sSrcFactor[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-sbxm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsBilXM.size()<=num) fsBilXM.push_back("");
      while (sBilFactorX.size()<=num) sBilFactorX.push_back(-1);
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -sbxm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      fsBilXM[num]=name; 
      sBilFactorX[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-xtlm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsTrgXM.size()<=num) fsTrgXM.push_back("");
      while (sTrgFactorX.size()<=num) sTrgFactorX.push_back(-1);
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -stxm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      fsTrgXM[num]=name; 
      sTrgFactorX[num]=atoi(fac.c_str());
      continue;
    }
    if (word.find("-ssxm")==0 &&narg<Argv.size()){
      string snum=word.substr(5);
      int num=atoi(snum.c_str());
      while (fsSrcXM.size()<=num) fsSrcXM.push_back("");
      while (sSrcFactorX.size()<=num) sSrcFactorX.push_back(-1);
      string data=string(Argv[narg++]);
      size_t pos=data.find(",");
      if (pos==string::npos) {cerr << "error: unparsed -ssxm parameter!" << endl; usage();}
      string name=data.substr(pos+1);
      string fac=data.substr(0,pos);
      fsSrcXM[num]=name; 
      sSrcFactorX[num]=atoi(fac.c_str());
      continue;
    }
    //search settings
    if (word.compare("-s")==0 && narg<Argv.size())      {strategy=string(Argv[narg++]); continue;}
    if (word.compare("-b")==0 && narg<Argv.size())      {stacksize=atoi(Argv[narg++].c_str()); continue;}
    if (word.compare("-t")==0 && narg<Argv.size())      {tnb=atoi(Argv[narg++].c_str()); continue;}
    //Bonus/Penalties/distortion
    if (word.compare("-ld")==0 && narg<Argv.size())     {ld=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lp0")==0 && narg<Argv.size())    {lp0=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lp1")==0 && narg<Argv.size())    {lp1=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lp2")==0 && narg<Argv.size())    {lp2=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lg")==0 && narg<Argv.size())     {lg=atof(Argv[narg++].c_str()); continue;}
    //lexicalized RM
    if (word.compare("-lmc")==0 && narg<Argv.size())    {lmc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lsc")==0 && narg<Argv.size())    {lsc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-ldc")==0 && narg<Argv.size())    {ldc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lcc")==0 && narg<Argv.size())    {lcc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lfc")==0 && narg<Argv.size())    {lfc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lbc")==0 && narg<Argv.size())    {lbc=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lmp")==0 && narg<Argv.size())    {lmp=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lsp")==0 && narg<Argv.size())    {lsp=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-ldp")==0 && narg<Argv.size())    {ldp=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lcp")==0 && narg<Argv.size())    {lcp=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lfp")==0 && narg<Argv.size())    {lfp=atof(Argv[narg++].c_str()); continue;}
    if (word.compare("-lbp")==0 && narg<Argv.size())    {lbp=atof(Argv[narg++].c_str()); continue;}
    if (word.find("-la")==0 && narg<Argv.size()){
      string snum=word.substr(3);
      int num=atoi(snum.c_str());
      while (la.size()<=num) la.push_back(0);
      la[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lb")==0 && narg<Argv.size()){
      string snum=word.substr(3);
      int num=atoi(snum.c_str());
      while (lb.size()<=num) lb.push_back(0);
      lb[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lt")==0 && narg<Argv.size()){
      string snum=word.substr(3);
      int num=atoi(snum.c_str());
      while (lt.size()<=num) lt.push_back(0);
      lt[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-ls")==0 && narg<Argv.size()){
      string snum=word.substr(3);
      int num=atoi(snum.c_str());
      while (ls.size()<=num) ls.push_back(0);
      ls[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lsb")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lsb.size()<=num) lsb.push_back(0);
      lsb[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lst")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lst.size()<=num) lst.push_back(0);
      lst[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lss")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lss.size()<=num) lss.push_back(0);
      lss[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lxb")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lxb.size()<=num) lxb.push_back(0);
      lxb[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lxt")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lxt.size()<=num) lxt.push_back(0);
      lxt[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    if (word.find("-lxs")==0 && narg<Argv.size()){
      string snum=word.substr(4);
      int num=atoi(snum.c_str());
      while (lxs.size()<=num) lss.push_back(0);
      lxs[num]=atof(Argv[narg++].c_str()); 
      continue;
    }
    //other
    if (word.compare("-threads")==0 && narg<Argv.size()) {nthreads=atoi(Argv[narg++].c_str()); continue;}
    if (word.compare("-nbest")==0 && narg<Argv.size())   {nbest=atoi(Argv[narg++].c_str()); continue;}
    if (word.compare("-dropoov")==0)                     {dropoov=true; continue;}
    if (word.compare("-units")==0)                       {units=true; continue;}
    if (word.compare("-ograph")==0)                      {ograph=true; continue;}
    if (word.compare("-help")==0)                        {help=true; continue;}
    if (word.compare("-verbose")==0)                     {verbose=true; continue;}
    cerr << "error: unparsed parameter: " << word << endl;
    usage(); 
  }
  
  /***************************************/
  /********* testing parameters **********/
  /***************************************/
  if (help) usage();
  if (fin.size()==0){
    cerr << "error: missing -i parameter" << endl;
    usage();
  }
  if (firstSent<0){
    cerr << "error: -f parameter must be > 0" << endl;
    usage();
  }
  if (lastSent<0){
    cerr << "error: -l parameter must be > 0" << endl;
    usage();
  }
  if (fout.size()==0){
    cerr << "error: missing -o parameter" << endl;
    usage();
  }
  if (strategy.compare("2J")!=0 && strategy.compare("J")!=0){
    cerr << "error: -s parameter must be J | 2J" << endl;
    usage();
  }
  if (nthreads<=0){
    cerr << "error: -threads parameter must be > 0" << endl;
    usage();
  }
  if (nbest<0){
    cerr << "error: -nbest parameter must be >= 0" << endl;
    usage();
  }
  if (nthreads>1 && verbose){
    cerr << "error: verbose output can only be used when running on ONE single thread" << endl;
    usage();
  }
  if (lb.size()>fBilLM.size()){
    cerr << "error: incompatible BilLM weights" << endl;
    usage();
  }
  if (lt.size()>fTrgLM.size()){
    cerr << "error: incompatible TrgLM weights" << endl;
    usage();
  }
  if (ls.size()>fSrcLM.size()){
    cerr << "error: incompatible SrcLM weights" << endl;
    usage();
  }
  if (lsb.size()>fsBilLM.size()){
    cerr << "error: incompatible sBilLM weights" << endl;
    usage();
  }
  if (lst.size()>fsTrgLM.size()){
    cerr << "error: incompatible sTrgLM weights" << endl;
    usage();
  }
  if (lss.size()>fsSrcLM.size()){
    cerr << "error: incompatible sSrcLM weights" << endl;
    usage();
  }


  if (lxb.size()>fsBilXM.size()){
    cerr << "error: incompatible sBilXM weights" << endl;
    usage();
  }
  if (lxt.size()>fsTrgXM.size()){
    cerr << "error: incompatible sTrgXM weights" << endl;
    usage();
  }
  if (lxs.size()>fsSrcXM.size()){
    cerr << "error: incompatible sSrcXM weights" << endl;
    usage();
  }
  cerr << "i       : " << fin << endl;
  cerr << "f       : " << firstSent; if (firstSent==0) cerr << " (1)"; cerr << endl;
  cerr << "l       : " << lastSent; if (lastSent==0) cerr << " (all)"; cerr << endl;
  cerr << "o       : " << fout << endl;
  if (fconf.size()>0) cerr << "c       : " << fconf << endl;
  cerr << "t       : " << tnb << endl;
  cerr << "b       : " << stacksize << endl;
  cerr << "s       : " << strategy << endl;
  for (int i=0;i<fBilLM.size();i++) {cerr << "blm" << i << "    : " << fBilLM[i] << " (bilFactor:" << BilFactor[i] << ", incrUNK:" << BilUnk[i] << ")" << endl;}
  for (int i=0;i<fTrgLM.size();i++) {cerr << "tlm" << i << "    : " << fTrgLM[i] << " (trgFactor:" << TrgFactor[i] << ", incrUNK:" << TrgUnk[i] << ")" << endl;}
  for (int i=0;i<fSrcLM.size();i++) {cerr << "slm" << i << "    : " << fSrcLM[i] << " (srcFactor:" << SrcFactor[i] << ", incrUNK:" << SrcUnk[i] << ")" << endl;}
  for (int i=0;i<fsBilLM.size();i++){cerr << "sblm"<< i << "    : " << fsBilLM[i] << " (bilFactor:" << sBilFactor[i] << ", incrUNK:" << sBilUnk[i] << ")" << endl;}
  for (int i=0;i<fsTrgLM.size();i++){cerr << "stlm"<< i << "    : " << fsTrgLM[i] << " (trgFactor:" << sTrgFactor[i] << ", incrUNK:" << sTrgUnk[i] << ")" << endl;}
  for (int i=0;i<fsSrcLM.size();i++){cerr << "sslm"<< i << "    : " << fsSrcLM[i] << " (srcFactor:" << sSrcFactor[i] << ", incrUNK:" << sSrcUnk[i] << ")" << endl;}
  for (int i=0;i<fsBilXM.size();i++){cerr << "sbxm"<< i << "    : " << fsBilXM[i] << " (bilFactor:" << sBilFactorX[i] << ")" << endl;}
  for (int i=0;i<fsTrgXM.size();i++){cerr << "stxm"<< i << "    : " << fsTrgXM[i] << " (trgFactor:" << sTrgFactorX[i] << ")" << endl;}
  for (int i=0;i<fsSrcXM.size();i++){cerr << "ssxm"<< i << "    : " << fsSrcXM[i] << " (srcFactor:" << sSrcFactorX[i] << ")" << endl;}
  for (int i=0;i<lb.size();i++) {cerr << "lb" << i << "     : " << lb[i] << endl;}
  for (int i=0;i<lt.size();i++) {cerr << "lt" << i << "     : " << lt[i] << endl;}
  for (int i=0;i<ls.size();i++) {cerr << "ls" << i << "     : " << ls[i] << endl;}
  for (int i=0;i<lsb.size();i++){cerr << "lsb"<< i <<  "    : " << lsb[i] << endl;}
  for (int i=0;i<lst.size();i++){cerr << "lst"<< i <<  "    : " << lst[i] << endl;}
  for (int i=0;i<lss.size();i++){cerr << "lss"<< i <<  "    : " << lss[i] << endl;}
  for (int i=0;i<lsb.size();i++){cerr << "lxb"<< i <<  "    : " << lxb[i] << endl;}
  for (int i=0;i<lst.size();i++){cerr << "lxt"<< i <<  "    : " << lxt[i] << endl;}
  for (int i=0;i<lss.size();i++){cerr << "lxs"<< i <<  "    : " << lxs[i] << endl;}
  for (int i=0;i<la.size();i++) {cerr << "la" << i << "     : " << la[i] << endl;}
  if (lmc!=0) cerr << "lmc     : " << lmc << endl;
  if (lsc!=0) cerr << "lsc     : " << lsc << endl;
  if (ldc!=0) cerr << "ldc     : " << ldc << endl;
  if (lcc!=0) cerr << "lcc     : " << lcc << endl;
  if (lfc!=0) cerr << "lfc     : " << lfc << endl;
  if (lbc!=0) cerr << "lbc     : " << lbc << endl;
  if (lmp!=0) cerr << "lmp     : " << lmp << endl;
  if (lsp!=0) cerr << "lsp     : " << lsp << endl;
  if (ldp!=0) cerr << "ldp     : " << ldp << endl;
  if (lcp!=0) cerr << "lcp     : " << lcp << endl;
  if (lfp!=0) cerr << "lfp     : " << lfp << endl;
  if (lbp!=0) cerr << "lbp     : " << lbp << endl;
  if (lg!=0)  cerr << "lg      : " << lg << endl;
  if (ld!=0)  cerr << "ld      : " << ld << endl;
  if (lp0!=0) cerr << "lp0     : " << lp0 << endl;
  if (lp1!=0) cerr << "lp1     : " << lp1 << endl;
  if (lp2!=0) cerr << "lp2     : " << lp2 << endl;

  cerr << "dropoov : " << dropoov << endl;
  cerr << "ograph  : " << ograph << endl;
  cerr << "nbest   : " << nbest << endl;
  cerr << "units   : " << units << endl;
  cerr << "threads : " << nthreads << endl;
  cerr << "verbose : " << verbose << endl;
  ostringstream lambdas;
  for (int i=0;i<lb.size();i++) {lambdas << " -lb" << i << " " << lb[i];}
  for (int i=0;i<lt.size();i++) {lambdas << " -lt" << i << " " << lt[i];}
  for (int i=0;i<ls.size();i++) {lambdas << " -ls" << i << " " << ls[i];}
  for (int i=0;i<lsb.size();i++){lambdas << " -lsb" <<i << " " << lsb[i];}
  for (int i=0;i<lst.size();i++){lambdas << " -lst" <<i << " " << lst[i];}
  for (int i=0;i<lss.size();i++){lambdas << " -lss" <<i << " " << lss[i];}
  for (int i=0;i<lxb.size();i++){lambdas << " -lxb" <<i << " " << lxb[i];}
  for (int i=0;i<lxt.size();i++){lambdas << " -lxt" <<i << " " << lxt[i];}
  for (int i=0;i<lxs.size();i++){lambdas << " -lxs" <<i << " " << lxs[i];}
  for (int i=0;i<la.size();i++) {lambdas << " -la" << i << " " << la[i];}
  if (lmc!=0) lambdas << " -lmc " << lmc;
  if (lsc!=0) lambdas << " -lsc " << lsc;
  if (ldc!=0) lambdas << " -ldc " << ldc;
  if (lcc!=0) lambdas << " -lcc " << lcc;
  if (lfc!=0) lambdas << " -lfc " << lfc;
  if (lbc!=0) lambdas << " -lbc " << lbc;
  if (lmp!=0) lambdas << " -lmp " << lmp;
  if (lsp!=0) lambdas << " -lsp " << lsp;
  if (ldp!=0) lambdas << " -ldp " << ldp;
  if (lcp!=0) lambdas << " -lcp " << lcp;
  if (lfp!=0) lambdas << " -lfp " << lfp;
  if (lbp!=0) lambdas << " -lbp " << lbp;
  if (lg!=0)  lambdas << " -lg " << lg;
  if (ld!=0)  lambdas << " -ld " << ld;
  if (lp0!=0) lambdas << " -lp0 " << lp0;
  if (lp1!=0) lambdas << " -lp1 " << lp1;
  if (lp2!=0) lambdas << " -lp2 " << lp2;
  cerr << "weights :" << lambdas.str() << endl;

  /***************************************/
  /********* opening out files ***********/
  /***************************************/
  f_out.open((fout).c_str());
  if (verbose) f_verbose.open((fout+".VERBOSE").c_str());
  if (ograph)  f_graph.open((fout+".GRAPH").c_str());
  if (nbest)   f_nbest.open((fout+".NBEST").c_str());
  if (units)   f_units.open((fout+".UNITS").c_str());
}

void Argument::usage(){
  cerr << "usage : bincoder [I/O] [Search settings] [Model files] [Model weights] [Other]" << endl;
  cerr << "  I/O:" << endl;
  cerr << "    -i                   s : input file" << endl;
  cerr << "    -f                   i : first sentence to translate in input file (0:first of ifile)    [default " << firstSent << "]" << endl;
  cerr << "    -l                   i : last sentence to translate in input file  (0:last of ifile)     [default " << lastSent << "]" << endl;
  cerr << "    -o                   s : output file" << endl;
  cerr << "    -c                   s : config file" << endl;
  cerr << "  Search settings:" << endl;
  cerr << "    -s                   s : search strategy                                                 [default " << strategy << "]" << endl;
  cerr << "                             'J' (J stacks) hyps covering the same number of source words" << endl;
  cerr << "                             '2J' (up to 2^J stacks) hyps covering the same source words" << endl; 
  cerr << "    -t                   i : consider i-best tuple translation choices (0:all choices)       [default " << tnb << "]" << endl;
  cerr << "    -b                   i : expand at most i-best states of each stack (0:expand all)       [default " << stacksize << "]" << endl;
  cerr << "  Model files:" << endl;
  cerr << "    -{b,t,s}lm(i)  j[,k],s : i-th (b:bilingual, t:target, s:source) LM (factor j)            (i>=0, j>=0)" << endl;
  cerr << "    -s{b,t,s}lm(i) j[,k],s : i-th sent-based (b:bilingual, t:target, s:source) LM (factor j) (i>=0, j>=0)" << endl;
  cerr << "                             increase by k the cost of p(<unk>|...)                          [default 0]" << endl;
  cerr << "    -s{b,t,s}xm(i)     j,s : i-th sent-based (b:bilingual, t:target, s:source) XM (factor j) (i>=0, j>=0)" << endl;
  cerr << "  Model weights:" << endl;
  cerr << "    -l{b,t,s}(i)         f : i-th (b:bilingual, t:target, s:source) LM                       (i>=0)" << endl;
  cerr << "    -ls{b,t,s}(i)        f : i-th sentence-based (b:bilingual, t:target, s:source) LM        (i>=0)" << endl;
  cerr << "    -lx{b,t,s}(i)        f : i-th sentence-based (b:bilingual, t:target, s:source) XM        (i>=0)" << endl;
  cerr << "    -la(i)               f : i-th tuple (uncontextualized) model                             (i>=0)" << endl;
  cerr << "    -l{m,s,d,c,f,b}{c,p} f : lexicalized RM" << endl;
  cerr << "    -lg                  f : input graph" << endl;
  cerr << "    -ld                  f : distortion penalty" << endl;
  cerr << "    -lp{0,1,2}           f : bonus models (0:tuple, 1:target word, 2:source word)" << endl;
  cerr << "  Other:" << endl;
  cerr << "    -dropoov               : drop OOV (source) words                                         [default " << dropoov << "]" << endl;
  cerr << "    -ograph                : ouput graph in ofile.GRAPH                                      [default " << ograph << "]" << endl;
  cerr << "    -nbest               i : ouput i-best hyps in ofile.NBEST                                [default " << nbest << "]" << endl;
  cerr << "    -units                 : write units in ofile.UNITS                                      [default " << units << "]" << endl;
  cerr << "    -threads             i : use i threads                                                   [default " << nthreads << "]" << endl;
  cerr << "    -verbose               : verbose output in ofile.VERBOSE                                 [default " << verbose << "]" << endl;
  cerr << "    -help                  : this help" << endl;
  cerr << endl;
  exit(1);
}

