#ifndef _TESTFILE
#define _TESTFILE

#include "Auxiliar.h"
#include "Argument.h"

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

class TestFile{
 public:
  vector<vector<string> > Data;
  vector<string> description;
  void read(Argument &);
};

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

class Tunit{
 public:
  vector<int> srcIndex;
  vector<string> srcTunit;
  vector<string> trgTunit;
  vector<float> Scores;
  vector<float> lexReordering;
  vector<string> bilFactors;
  vector<vector<string> > srcFactors;
  vector<vector<string> > trgFactors;
  vector<int> Arc;
  float scoreArc;
  float weightedScore;
  Tunit(Argument &, vector<string> &, vector<string> &);
};

class settunitminorcost{
 public:
  bool operator()(Tunit const u1, Tunit const u2) const{return u1.weightedScore <= u2.weightedScore;}
};

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

class Sentence{
 public:
  //input lattice
  hash_map<int, hash_map<string, vector<pair<int,float> > > > node2word2vec_nodecost;
  hash_set<int> hset_nodesfinal;
  set<int> set_nodestopsort;
  //units
  hash_map<vector<string>, set<Tunit,settunitminorcost>, hashfvecstring, hasheqvecstring> srcTunit2set_Tunit;
  hash_set<vector<string>, hashfvecstring, hasheqvecstring > hset_srcTunits_prefixs;
  vector<Tunit> Tunits;
  hash_map<int, hash_set<int> > node2hset_TunitsPos;
  //statistics
  int hypAdded,hypExpanded,hypRecombined,hypPruned;

  Sentence(Argument &,TestFile &, int);
  ~Sentence(){};
  void addTunit(Argument &,string,vector<string> &);
  void addLattice(string);
  void compute_structure(Argument &,int,vector<string> &,int);
  vector<vector<int> > getPathNodes(int,vector<string> &);
  float getPathScore(vector<int> &,vector<string> &);
};

#endif
