#!/usr/bin/perl

$bincoder = $ENV{'BINCODER'};
$nbest=300;

$usage="usage: bincoder.perl -nbest i -o s [-bincoder s] [-gph2nbst s] [bincoderparams]
   -nbest          i : nbest size                    [default $nbest]
   -o              s : hypotheses output file
   -bincoder       s : bincoder binary               [default $bincoder]
   -gph2nbst       s : graph-to-nbest binary         [default $gph2nbst]
   -bincoderparams s : parameters passed to bincoder
";

while ($#ARGV>=0){
    $tok = shift @ARGV;
    if ($tok eq "-o" && $#ARGV>=0)        {$fout=$ARGV[0];}
    if ($tok eq "-nbest" && $#ARGV>=0)    {$nbest=shift @ARGV;next;}
    if ($tok eq "-bincoder" && $#ARGV>=0) {$bincoder=shift @ARGV;next;}
    if ($tok eq "-gph2nbst" && $#ARGV>=0) {$gph2nbst=shift @ARGV;next;}
    $pars[$#pars+1]=$tok;
}

die "error: undefined $fout parameter!\n$usage" unless (defined $fout); 

$cmd="$bincoder/bin/bincoder @pars";
system ($cmd);

$cmd="$bincoder/bin/gph2nbst -nbest $nbest < $fout.GRAPH > $fout.NBEST";
system ($cmd);

