#!/usr/bin/perl

$bincoder = $ENV{'BINCODER'};
$scorer="$bincoder/src/Evaluate/mteval-v13a.pl";

$usage="evaluate.perl -tst f {-ref f,-refs f} [-scorer f] [-v]\n";
$verbose=0;
while ($#ARGV>=0){
    $tok=shift @ARGV;
    if ($tok eq "-tst" && $#ARGV>=0){$ftst=shift @ARGV; next;}
    if ($tok eq "-ref" && $#ARGV>=0){$fref[$#fref+1]=shift @ARGV; next;}
    if ($tok eq "-refs" && $#ARGV>=0){$frefs=shift @ARGV; next;}
    if ($tok eq "-scorer" && $#ARGV>=0){$scorer=shift @ARGV; next;}
    if ($tok eq "-v"){$verbose=1; next;}
    $args[$#args+1]=$tok;
}

########################
### check parameters
########################

if (defined $frefs){
    @refs=glob("$frefs*");
    foreach $ref (@refs){$fref[$#fref+1]=$ref;}
}

die "error: missing -tst parameter\n$usage" unless (defined $ftst);
die "error: missing -ref/s parameter$usage\n" unless (defined @fref);
foreach $file (@fref,$ftst) {die "error: unavailable $file\n" unless (-e $file);}

print STDERR "scr: $scorer\n";
$currDir = `pwd`;
chomp $currDir;
print STDERR "pwd: $currDir\n";
print STDERR "tst: $ftst\n";
print STDERR "ref: @fref\n";

########################
### build src/tst files
########################

open (OTST,">$ftst.sgm") or die "error: unavailable output test file: $ftst.sgm\n";
open (OSRC,">$ftst.src.sgm") or die "error: impossible to open output source file: $ftst.src.sgm\n";

print OTST "<tstset setid=\"setid\" srclang=\"any\" trglang=\"trglang\">
<doc sysid=\"sysid\" docid=\"docid\" genre=\"genre\" origlang=\"origlang\">
";
print OSRC "<srcset setid=\"setid\" srclang=\"any\">
<doc docid=\"docid\" genre=\"genre\" origlang=\"origlang\">
";

$numseg=1;
open (TST,"<$ftst") or die "error: unavailable test file: $ftst\n";
while (<TST>){
    chomp;
    print OSRC "<p>
<seg id=\"$numseg\">$_<\/seg>
<\/p>
";
    print OTST "<p>
<seg id=\"$numseg\">$_<\/seg>
<\/p>
";
    $numseg++;
}
print OSRC "<\/doc>
<\/srcset>
";
print OTST "<\/doc>
<\/tstset>
";
close TST;

close OSRC;
close OTST;

########################
### build ref files
########################

open (OREF,">$ftst.ref.sgm") or die "error: impossible to open output reference file: $ftst.ref.sgm\n";
print OREF "<refset setid=\"setid\" srclang=\"any\" trglang=\"trglang\">
";
for ($f=0;$f<=$#fref;$f++){
    print OREF "<doc docid=\"docid\" genre=\"genre\" origlang=\"origlang\" sysid=\"r$f\">\n";
    open (REF,"<$fref[$f]") or die "error: unavailable reference file: $fref[$f]\n";
    $numseg=1;
    while (<REF>){
	chomp;
	print OREF "<p>
<seg id=\"$numseg\">$_<\/seg>
<\/p>
";
	$numseg++;
    }
    close REF;
    print OREF "<\/doc>\n";
}
print OREF "<\/refset>\n";
close OREF;

$cmd="$scorer -r $ftst.ref.sgm -s $ftst.src.sgm -t $ftst.sgm @args";
open (CMD,"$cmd |") or die "error: runing $cmd\n";
$bleu="error scoring";
$nist="error scoring";
while (<CMD>){
    if ($verbose) {print; next;}    
    if (/^BLEU score = ([^ ]+)/){
	$bleu=$1*100;
	print "BLEU = $bleu\n";
    }
    if (/^NIST score = ([^ ]+)/){
	print "NIST = $1\n";
    }
}

$cmd="rm -f $ftst.ref.sgm $ftst.src.sgm $ftst.sgm";
system $cmd;
