#!/usr/bin/perl

$BINCODER=$ENV{'BINCODER'};
$decoder="$BINCODER/bin/bincoder";

$sizecol=6;
$usage="USAGE: mert-say.pl [-sizecol i] flog 
   flog      : file with optimization log
   sizecol i : columns size [default 5]
";

while ($#ARGV>=0){
    $tok=shift @ARGV;
    if ($tok =~ /^\-sizecol$/) {$sizecol=shift @ARGV;next;}
    if ($#ARGV==-1) {$flog=$tok;next;}
    die "error: unparsed parameter $tok\n$usage";
}

$sizecol--;
$bestbleu=0;
open (FILE,"<$flog") or die "error: unavailable log file: $flog\n";
while (<FILE>){
    ### weights : -lb0 1 -lt0 1 -la0 1 -la1 1 -la2 1 -la3 1 -lmc 1 -lsc 1 -ldc 1 -lmp 1 -lsp 1 -ldp 1 -ld 1 -lp0 1 -lp1 1
    chomp;
    if (/^weights \: (.+)$/){
	$values=$1;
	$features=$1;
	$weights=$1;
	$values=~s/\-[^ ]+ ([^ ]+)/$1/g; $values=~s/ +/ /g;
	$features=~s/\-([^ ]+) [^ ]+/$1/g; $features=~s/ +/ /g;
#	print "values: $values\n";
#	print "features: $features\n";
	$lambdas[$#lambdas+1]=$values;
	next;
    }
    if (/^BLEU SCORE for [^\:]+\:(.+)$/){
	$bleu[$#bleu+1]=$1;
	if ($bleu[$#bleu]>$bestbleu){
	    $bestbleu=$bleu[$#bleu];
	    $bestweights=$weights;
	}
	next
    }
    if (/^Training finished at/){
	$finished=1;
    }
}
close FILE;

if ($#lambdas==$#bleu+1 && !$finished) {$bleu[$#bleu+1]="run";}
die "diff unparsed file nLambdas:$#lambdas nBleu:$#bleu!\n" if ($#lambdas != $#bleu);

$features=&format($features);
print $features." | BLEU\n";
$features =~ s/./\=/g;
print $features."========\n";
for ($n=0;$n<=$#lambdas;$n++){
    $bleu[$n].="*" if ($bleu[$n] eq $bestbleu);
    print &format($lambdas[$n])." | $bleu[$n]\n";
}
print $features."========\n";

if ($finished) {
    print "[FINISHED]\n";
    print "$bestweights\n"
}
else {print "[RUNNING]\n";}

###################################################################
###################################################################
###################################################################

sub format(){
    $entry = @_[0];
    @ENTRY = split / /,$entry;
    for ($i=0;$i<=$#ENTRY;$i++){
	@entry = split //,$ENTRY[$i];
	while ($#entry < $sizecol) {$entry[$#entry+1]=" ";}
	while ($#entry > $sizecol) {splice(@entry,$#entry,1);}
	$ENTRY[$i]=join("",@entry);
    }
    join(" ",@ENTRY);
}
