#!/usr/bin/perl

$verbose=0;
$usage="unf2utrn -trn f [-verbose] < unfoldNULL
   -trn    f : source training data to unfold
   -verbose  : verbose output
";

while (@ARGV>0){
    $tok=shift @ARGV;
    if ($tok=~/^\-trn$/ && @ARGV>0)  { $ftrn=shift @ARGV; next; }
    if ($tok=~/^\-verbose$/)         { $verbose=1; next; }
    die "error: unparsed parameter: $tok\n$usage";
}

die "ERROR: missing parameter -trn\n$usage" unless (defined $ftrn);

print STDERR "   ===================================================
     unf2utrn.perl : to unfold the training src file
     jmcrego[at]limsi[dot]fr, June 2011        
   ===================================================
";

print STDERR "Reading $ftrn\n";
print STDERR "Reading unfold units\n";
open (FILE,"<$ftrn") or die "ERROR: unavailable trn file: $ftrn\n";
$nsent=0;
$nline=0;
while (<>){
    if (/^EOS$/) {
	$trn=<FILE>;
	chomp $trn;
	@TRN=split / /,$trn;
	&output_sentence();
	$#IND=-1;
	$nsent++;
	if ($nsent%10000==0){if ($nsent%100000==0){print STDERR $nsent;} else {print STDERR ".";}}
	next;
    }
    chomp;
    $nline++;
    @tokens=split / \|\|\| /;
    if ($#tokens<3) {die "error: unparsed entry at line $nline: $_\n";}
    @ind=split / /,$tokens[3];
    next if ($#ind==0 && $ind[0]==-1);
    for ($i=0;$i<=$#ind;$i++) {$IND[$#IND+1]=$ind[$i];}
}
close FILE;
print STDERR "Done!\n";

#####################################################################################
#####################################################################################
#####################################################################################

sub output_sentence(){
    die "error: diff num of tokens in sentence $nsent\nIND: @IND\nTRN: @TRN\n" if ($#IND!=$#TRN);
    $#UTRN=-1;
    for ($i=0;$i<=$#IND;$i++){
	$UTRN[$#UTRN+1]=$TRN[$IND[$i]];
    }
    print "@UTRN\n";
}


